<?php

///////////////////////////////////////////////////////////////////////////////////
//    (   )
///////////////////////////////////////////////////////////////////////////////////
function checkDataValue($val, $units)
{
   switch(trim($units)) {

      case "C":
         $minVal=-80;
         $maxVal=80; //1wire   85
         break;
      case "mm":
         $minVal=650;
         $maxVal=900;
         break;
      case "lux":
         $minVal=0;
         $maxVal=30000; //     - 20000 
         break;
      case "%":
         $minVal=2;
         $maxVal=101;
         break;
      case "MB":
      case "kB":
         $minVal=0;
         $maxVal=50000000000;
         break;
      case "rg":
         $minVal=-1;
         $maxVal=50000000000;
         break;
      default:
         $minVal=-100;
         $maxVal=100;
   }

   if ($val> $minVal and $val < $maxVal) {
      return $val;
   } else {
      return VOID;
   }

}

///////////////////////////////////////////////////////////////////////////////////
// ""   X
///////////////////////////////////////////////////////////////////////////////////
function cleanXLabels()
{
   global $labels;
   global $Scale;

   //print_r($labels);

   $elem0=current($labels);
   $hour_st="";
   foreach($labels as $i=>$elem)
   {
      $t=strtotime($elem);
      $hour=date("H",$t);
      if (fmod($hour,$Scale) == 0) $hour_st=$hour;
      $labels[$i]=$hour_st.":00";
   }
}
///////////////////////////////////////////////////////////////////////////////////
function ___cleanXLabels()
{
   global $labels;
   global $Scale;

   if (count($labels)>0) {
      foreach($labels as $i=>$elem)
      {
         //print $elem."<br>";
      }


      $elem0=current($labels);
      foreach($labels as $i=>$elem)
      {
         $t=strtotime($elem);
         $t0=strtotime($elem0);
         if (!(date("i",$t) <= date("i",$t0))):
            $labels[$i]="";
         else:
            $labels[$i]=date("H",$t).":00";
         endif;
         $elem0=$elem;
      }

      foreach($labels as $i=>$elem)
      {
         if ($elem!=""):
            if ($elem % $Scale != 0 ):
               $labels[$i]="";
            endif;
         endif;
      }
   }

}

///////////////////////////////////////////////////////////////////////////////////
//    - Ping     no ping
///////////////////////////////////////////////////////////////////////////////////
function __scaleData()
{
   global $labels,$data;
   global $data_onboard,$data_in,$data_out;
   global $Scale;


   foreach($data as $data_arr_idx=>$data_arr)
   {
       $i=0;$movsum=0;$movnum=0;$data_ret=array();
       foreach($data_arr as $i=>$elem)
       {
          if ($elem!=VOID) {
             $movsum+=$elem;
             $movnum++;
          }
          if ((++$i % $Scale)==0):
             if ($movnum!=0) {
               $avgval=$movsum/$movnum;
             } else {
                $avgval=VOID;
             }
             $data_ret[]=$avgval;
             $movsum=0;
             $movnum=0;
          endif;
       }
       $data[$data_arr_idx]=$data_ret;
   }

   $i=0;$movsum=0;
   foreach($labels as $i=>$elem)
   {
      if (($i++ % $Scale)==0):
         $label_ret[]=$elem;
      endif;
   }
   $labels=$label_ret;

}

function calcDewPoint($Temp,$RH)
// RH  , .. 65
{

    $a_coef=	6.112;
    $b_coef=	17.67;
    $c_coef=	243.5;
    $gamma=	log($RH/100)+$b_coef*$Temp/($c_coef+$Temp);
    $Tdp= $c_coef*$gamma/($b_coef - $gamma);

    return $Tdp;
}

//  ""
function calcWetIndex($wsv,$dhum)
{
    $wetval=max(1023-$wsv,0); // ; 1023 - . ,       .

    if ($wetval<=4) $wetval=0;


    if ($wetval<=4):
        $wetidx=0;
    elseif ($wetval<=30):
        $wetidx=1;
    elseif ($wetval<=100):
        $wetidx=2;
    elseif ($wetval<=300):
        $wetidx=3;
    elseif ($wetval<=600):
        $wetidx=4;
    elseif ($wetval<=1000):
        $wetidx=5;
    endif;

    return $wetval; //  ,   

}

?>