<?php
/* Переменные для разных сред запуска */
 if ($_SERVER["HTTP_HOST"]=='localhost'):
   $host="localhost";
   $login="root";
   $pass="";
   $dbname="symfony";
else:
   $host=""; //адрес mysql серевера
   $login=""; //логин к mysql серверу
   $pass="";//праоль для досутпа к mysql серверу
   $dbname=""; //имя базы данных, в которой созданы необходимые таблицы
endif;

 /* pChart library inclusions */
include("pChart2.1.3/class/pData.class.php");
include("pChart2.1.3/class/pDraw.class.php");
include("pChart2.1.3/class/pImage.class.php");
include("pChart2.1.3/class/pCache.class.php");

require("displaydata_lib.php");

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* Инициализация переменных */

$labels=array(VOID);
$data=array();
$data_set=array(
   1=>array("name"=> "Skytemp", "field"=> "otemp", "units"=>" C"),
   2=>array("name"=> "owt1", "field"=> "owt1", "units"=>" C"),
   4=>array("name"=> "atemp", "field"=> "atemp", "units"=>" C"),
   7=>array("name"=> "Cloudidx", "field"=> ""),
   8=>array("name"=> "Cloudlevel", "field"=> ""),
   9=>array("name"=> "Lightness", "field"=> "bhval", "units"=>" lux"),
   //10=>array("name"=> "Wet", "field"=> ""),
   //11=>array("name"=> "RG", "field"=> "rgc", "units"=>"rg"),
);

// initializing
foreach($data_set as $data_idx => $data_set_arr)
{
   $data[$data_idx]=array(VOID);
}

$CACHE_FILENAME="../cache/"."cache_cloud.png";
$CHART_TITLE="Cloud index data";

/* Настройка основных параметров */
define(CHECKINTERVAL,2*60); //интервал усреднения
define(CHECKINTERVAL_TOLERANCE,5); //для поиска пропусков

define(IMG_SIZE_X,1280); //Размер изображения по X
define(IMG_SIZE_Y,430);  //Размер изображения по Y

define(RECON_Y,50); // Y coord of recconect event point
define(MAX_PING_VAL,1500); // Максимальное значение величины пинга, до которого обрезаются еще большие

$Scale=$_GET['scale'];if ($Scale=="") $Scale=1;


/* Значения, используемые для отлдадки */
/*
$data[1]=array(-12,-12.5,-12.9,-12,-12,VOID,VOID,VOID,-14,-18);
$data[2]=array(-15,-15.5,-15.9,-14,-16,VOID,VOID,VOID,-15,-20);
$data[3]=array(-20,-25.5,-25.9,VOID,VOID,-24,-26,VOID,-25,-29);
$data[4]=array(-19.5,-24.2,-23.9,VOID,VOID,-24,-26,VOID,-25,-29);
$data[5]=array(-19.3,-24.5,VOID,-26.9,VOID,-23.9,-25.9,-25,VOID,-28.7);
$labels=array("2012-08-14 08:04:04","2012-08-14 08:09:04","2012-08-14 08:14:04","2012-08-14 08:19:04","2012-08-14 08:24:04",
			  "2012-08-14 08:29:04","2012-08-14 08:34:04","2012-08-14 08:39:04","2012-08-14 08:44:04","2012-08-14 08:49:04");
*/


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/* Вызов основных функций */
readData(); //Disable to test

//scaleData();
   #reverseYData();
   #parseReconData();
cleanXLabels();

#print count($data_onboard);
#print "<br>";
#print count($labels);
#print "<br>";
#print_r($labels);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 /* CAT:Line chart */
   /* Create and populate the pData object */
   $MyData = new pData();

   // initializing
   foreach($data_set as $data_idx=>$data_set_arr)
   {
      if ($data_set_arr["name"]!=""):
         $MyData->addPoints( $data[$data_idx],$data_set_arr["name"] );

         $MyData->setSerieWeight($data_set_arr["name"],0);
         $MyData->setSerieTicks($data_set_arr["name"],0);
      endif;
   }

   $MyData->setSerieOnAxis("Skytemp", 1);
   $MyData->setSerieOnAxis("owt1", 1);
   $MyData->setSerieOnAxis("btemp", 1);
   $MyData->setSerieOnAxis("atemp", 1);
   $MyData->setSerieOnAxis("dtemp", 1);
   $MyData->setSerieOnAxis("Lightness", 2);
   //$MyData->setSerieOnAxis("Wet", 3);
   //$MyData->setSerieOnAxis("RG", 4);

   $MyData->setAxisName(0,"Cloud index");
   $MyData->setAxisName(1,"Temp");
   $MyData->setAxisName(2,"Lux");
   $MyData->setAxisPosition(2,AXIS_POSITION_RIGHT);
   //$MyData->setAxisName(3,"Wet index");
   //$MyData->setAxisPosition(3,AXIS_POSITION_RIGHT);

   //$MyData->setAxisName(4,"RG");
   //$MyData->setAxisPosition(4,AXIS_POSITION_RIGHT);


   $MyData->setSerieWeight("Cloudidx",2);
   $MyData->setSerieWeight("Cloudlevel",0);
   $MyData->setSerieTicks("Cloudlevel",1);
   $MyData->setSerieWeight("Lightness",1);

   $MyData->addPoints($labels,"Labels");
   $MyData->setAbscissa("Labels");
   //$MyData->setXAxisDisplay(AXIS_FORMAT_TIME,"H:i");
   $MyData->setSerieDescription("Labels","Time");

   $Config = array("BreakVoid"=>TRUE, "BreakR"=>234, "BreakG"=>55, "BreakB"=>26,
                  "PlotSize"=>2
               );

   /* Create the cache object */
   $myCache = new pCache();

   /* Compute the hash linked to the chart data */
   $ChartHash = $myCache->getHash($MyData);

   /* Test if we got this hash in our cache already */
   if ( $myCache->isInCache($ChartHash))
   {
      /* If we have it, get the picture from the cache! */
      #$myCache->strokeFromCache($ChartHash); //вывод напрямую в браузер
      $myCache->saveFromCache($ChartHash,$CACHE_FILENAME); //вывод через файл
   }
   else
   {
      #print "out of hash";

      /* Create the pChart object */
      $myPicture = new pImage(IMG_SIZE_X,IMG_SIZE_Y,$MyData);

      /* Turn of Antialiasing */
      $myPicture->Antialias = FALSE;

      /* Add a border to the picture */
      $myPicture->drawRectangle(0,0,IMG_SIZE_X-1,IMG_SIZE_Y-1,array("R"=>0,"G"=>0,"B"=>0));

      /* Write the chart title */
      $myPicture->setFontProperties(array("FontName"=>"pChart2.1.3/fonts/Forgotte.ttf","FontSize"=>11));
      $myPicture->drawText(150,35,$CHART_TITLE,array("FontSize"=>20,"Align"=>TEXT_ALIGN_BOTTOMMIDDLE));

      /* Set the default font */
      $myPicture->setFontProperties(array("FontName"=>"pChart2.1.3/fonts/pf_arma_five.ttf","FontSize"=>6.2));

      /* Define the chart area */
      $myPicture->setGraphArea(80,40,IMG_SIZE_X-80,IMG_SIZE_Y-30);

      /* Draw the scale */
      $scaleSettings = array("XMargin"=>10,"YMargin"=>10,"Floating"=>TRUE,"GridR"=>200,"GridG"=>200,"GridB"=>200,"DrawSubTicks"=>FALSE,"CycleBackground"=>TRUE,"LabelingMethod"=>LABELING_DIFFERENT, "DrawYLines"=>array(0), "ScaleSpacing"=>10 );
      $myPicture->drawScale($scaleSettings);

      /* Turn on Antialiasing */
      $myPicture->Antialias = TRUE;

      /* Draw the line chart */
      $myPicture->drawLineChart($Config);
      //$myPicture->drawPlotChart($Config);

      /* Write the chart legend */
      $myPicture->drawLegend(540,20,array("Style"=>LEGEND_NOBORDER,"Mode"=>LEGEND_HORIZONTAL));

     /* Draw min max values */
     foreach($data_set as $data_idx=>$data_set_arr)
      {
         if ($data_set_arr["name"]!=""):
            $myPicture->drawText((105+ ++$i*(220-105)),42,"Min: ".round($minvalue[$data_idx],1).$data_set[$data_idx]["units"]."   Max: ".round($maxvalue[$data_idx],1).$data_set[$data_idx]["units"],array("FontSize"=>6,"Align"=>TEXT_ALIGN_BOTTOMLEFT));
         endif;
      }
      /* Дата генерации графика */
      $myPicture->drawText(IMG_SIZE_X-5,5,"Updated on: ".date("H:i d-m-Y"),array("FontSize"=>6,"Align"=>TEXT_ALIGN_TOPRIGHT));

      /* Push the rendered picture to the cache */
      $myCache->writeToCache($ChartHash,$myPicture);

      /* Render the picture */
      #$myPicture->autoOutput($CACHE_FILENAME); //напрямую в браузер или в файл (если из командной строки)
      $myPicture->Render($CACHE_FILENAME); //вывести в файл
      #$myPicture->Stroke(); //напрямую в браузер
   }

   header("Location: $CACHE_FILENAME");


///////////////////////////////////////////////////////////////////////////////////
// Прочитать из базы данных
///////////////////////////////////////////////////////////////////////////////////
function readData()
{
   global $host,$login, $pass, $dbname;
   global $data,$data_set;
   global $labels;
   global $Scale;
   global $maxvalue,$minvalue;


   //Открыть соединение с mysql
   $link = mysql_connect($host, $login, $pass);
   if (!$link) {  die('Ошибка соединения: ' . mysql_error());   }
   $SelectResult = mysql_select_db($dbname, $link);
   if (!$SelectResult) { die('Ошибка выбора базы данных: ' . mysql_error());   }

   // Расчитать горизонт времени, с которого берутся значения
   $read_data_start_time=time()-24*3600*$Scale;
   $read_data_start_timest=date("Y-m-d H:i:s",$read_data_start_time);

   //Прочитать данные из mysql
   $q="SELECT * FROM weather_data WHERE date>'$read_data_start_timest' ORDER BY date ASC";
   $res=mysql_query($q,$link);
   if (!$res) { die('Ошибка sql: ' . mysql_error());  }


   //Инициализация переменной "последнеяя прочитанная дата" значением горизонта времени
   $prevdate_time=$read_data_start_time;
   $last_included_time=0;

   //Инициализация min max значений и переменных для усредненния
   foreach($data_set as $data_arr_idx=>$data_arr)
   {
      $maxvalue[$data_arr_idx]=-1000;
      $minvalue[$data_arr_idx]=20000;
      $val_avg_value[$data_arr_idx]=0;
      $val_avg_count[$data_arr_idx]=0;
   }

   //------------------------------------------------------------
   //Основной цикл перебора данных из mysql
   //------------------------------------------------------------
   while($line=mysql_fetch_array($res))
   {

      $curdate=$line['date'];
      $curdate_time=strtotime($curdate);

      //------------------------------------------------------------
      //Вставить текущие значения (усредняя промежуточные)
      //------------------------------------------------------------

      // Прочитать значения
      foreach($data_set as $data_arr_idx=>$data_arr)
      {
         if ($data_set[$data_arr_idx]['field']!=""):
            $val_data[$data_arr_idx] = checkDataValue( $line[$data_set[$data_arr_idx]['field']], $data_set[$data_arr_idx]['units']);
         endif;
      }
      //РАСЧЕТНЫЕ ПОЛЯ!!!!
      $val_data[7]=abs($val_data[1]-(($val_data[2]<100 and $val_data[2]!="")?$val_data[2]:$val_data[3])); //Cloud index
      $val_data[8]=20;
      //$val_data[10]=calcWetIndex($line['wsv'],$line['dhum']); //$line['dhum'] на всякий случай, для проверки. Пока не используется


      //Сглаживание на 5и минутных интервалах (интервал усредения)
      if ($last_included_time==0) $last_included_time=$curdate_time;//Инициализация интервала сглаживания для первого значения

      if (($curdate_time-$last_included_time)<(CHECKINTERVAL*$Scale)):
      //если значение в пределах интервала усреднения, то усредняем значения

         foreach($data_set as $data_idx=>$data_arr)
         {
            if ($val_data[$data_idx]!=VOID and $val_data[$data_idx]!=""):
               $val_avg_value[$data_idx]=( $val_avg_value[$data_idx]*$val_avg_count[$data_idx] + $val_data[$data_idx] )/( $val_avg_count[$data_idx] + 1 );
               $val_avg_count[$data_idx]++;
            endif;
         }

      else:
      //Иначе - записываем значение в ряд!

         foreach($val_avg_value as $data_idx=>$cur_val)
         {
            $data[$data_idx][]=$cur_val;
            //Отметить максимальное/минимальное значение
            if ($cur_val!=VOID and $cur_val!="") {
               $maxvalue[$data_idx]=max($maxvalue[$data_idx],$cur_val);
               $minvalue[$data_idx]=min($minvalue[$data_idx],$cur_val);
            }
            // и инициализруем счетчики текущими значениям
            $val_avg_value[$data_idx]=$val_data[$data_idx];
            $val_avg_count[$data_idx]=1;
         }
         $last_included_time=$curdate_time;
         //Записываем label (делаем это предыдущим значеним даты, т.к. текущее значение - это уже следующий интервал усреднения
         $labels[]=$prevdate;

      endif;

      //------------------------------------------------------------
      //Вставить пропущенные данные каждые CHECKINTERVAL сек
      //------------------------------------------------------------

      $missed_interval_length=$curdate_time-$prevdate_time+CHECKINTERVAL_TOLERANCE; //добавляем 30 для того, чтобы 299 сек тоже учитывался
      $number_of_values_missed=max(floor($missed_interval_length/CHECKINTERVAL/$Scale),0);
      //print "[$missed_interval_length, n: $number_of_values_missed]<br>\n";

      for ($i=1; $i<$number_of_values_missed; $i++){
         foreach($data as $data_arr_idx=>$data_arr)
         {
            $data[$data_arr_idx][]=VOID;
         }
         $labelins=date("Y-m-d H:i:s",$prevdate_time+$i*CHECKINTERVAL*$Scale);
         $labels[]=$labelins;
      }

      $prevdate_time=$curdate_time;
      $prevdate=$curdate;
   }

   //------------------------------------------------------------
   //Проверить, нет ли пропусков с последнего элемента до "сейчас"
   //------------------------------------------------------------

   $missed_interval_length=time()-$prevdate_time+CHECKINTERVAL_TOLERANCE; //добавляем 30 для того, чтобы 299 сек тоже учитывался
   $number_of_values_missed=max(floor($missed_interval_length/CHECKINTERVAL/$Scale),0);
   #print "[$prevdate_time]";
   #print "[$interv, n: $numint]<br>\n";

   for ($i=1;$i<$number_of_values_missed;$i++){
      foreach($data as $data_idx=>$data_arr)
      {
         $data[$data_idx][]=VOID;
      }
      $labelins=date("Y-m-d H:i:s",$prevdate_time+$i*CHECKINTERVAL*$Scale);
      $labels[]=$labelins;
   }


   //Закрываем mysql соединение
   mysql_close($link);
}



?>